import { Component, Input, NgModule } from '@angular/core';
import { coerceNumberProperty } from '@angular/cdk/coercion';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
class NtProgressCircleComponent {
    constructor() {
        this._max = 100;
        this._value = 0;
        this._radius = 60;
        this.size = 'medium';
        this.color = '';
        this.class = '';
    }
    /**
     * @return {?}
     */
    get dasharray() {
        return this.radius * 2 * Math.PI;
    }
    /**
     * @return {?}
     */
    get width() { return this.radius * 2 + 20; }
    /**
     * @return {?}
     */
    get height() { return this.radius * 2 + 20; }
    /**
     * @param {?} value
     * @return {?}
     */
    set radius(value) { this._radius = coerceNumberProperty(value, 100); }
    /**
     * @return {?}
     */
    get radius() { return this._radius; }
    /**
     * @param {?} value
     * @return {?}
     */
    set max(value) { this._max = coerceNumberProperty(value, 100); }
    /**
     * @return {?}
     */
    get max() { return this._max; }
    /**
     * @param {?} value
     * @return {?}
     */
    set value(value) { this._value = coerceNumberProperty(value); }
    /**
     * @return {?}
     */
    get value() { return this._value; }
    /**
     * @return {?}
     */
    get percent() {
        /** @type {?} */
        const percent = this.value / this.max * 100;
        return percent > 100 ? 100 : percent;
    }
}
NtProgressCircleComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-progress-circle',
                template: "<svg attr.viewPort=\"0 0 {{width / 2}} {{height / 2}}\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" [attr.width]=\"width\" [attr.height]=\"height\"> <circle [attr.r]=\"radius\" [attr.cx]=\"width / 2\" [attr.cy]=\"height / 2\" fill=\"transparent\" [attr.stroke-dasharray]=\"dasharray\" [attr.stroke-dashoffset]=\"0\"></circle> <circle class=\"progress-meter-circle\" [attr.r]=\"radius\" [attr.cx]=\"width / 2\" [attr.cy]=\"height / 2\" fill=\"transparent\" [attr.stroke-dasharray]=\"dasharray\" [attr.stroke-dashoffset]=\"dasharray - (dasharray / 100 * percent)\"></circle> </svg> <!-- <div class=\"nt-progress-circle-inner\"><ng-content></ng-content></div> --> ",
                host: {
                    '[class]': '["nt-progress-circle", color, size, class].join(" ")'
                }
            },] },
];
NtProgressCircleComponent.propDecorators = {
    radius: [{ type: Input }],
    max: [{ type: Input }],
    value: [{ type: Input }],
    size: [{ type: Input }],
    color: [{ type: Input }],
    class: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
class NtProgressComponent {
    constructor() {
        this._max = 100;
        this._value = 0;
        this.size = 'medium';
        this.color = '';
        this.class = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set max(value) { this._max = coerceNumberProperty(value, 100); }
    /**
     * @return {?}
     */
    get max() { return this._max; }
    /**
     * @param {?} value
     * @return {?}
     */
    set value(value) { this._value = coerceNumberProperty(value); }
    /**
     * @return {?}
     */
    get value() { return this._value; }
    /**
     * @return {?}
     */
    get percent() {
        /** @type {?} */
        const percent = this.value / this.max * 100;
        return percent > 100 ? 100 : percent;
    }
}
NtProgressComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-progress',
                template: "<span class=\"progress-meter\" [style.width.%]=\"percent > 100 ? 100 : percent\"> <p class=\"progress-meter-text\"><ng-content></ng-content></p> </span> ",
                host: {
                    '[class]': '["progress", color, size, class].join(" ")'
                }
            },] },
];
NtProgressComponent.propDecorators = {
    max: [{ type: Input }],
    value: [{ type: Input }],
    size: [{ type: Input }],
    color: [{ type: Input }],
    class: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
class NtProgressModule {
}
NtProgressModule.decorators = [
    { type: NgModule, args: [{
                exports: [NtProgressComponent, NtProgressCircleComponent],
                declarations: [NtProgressComponent, NtProgressCircleComponent]
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

export { NtProgressModule, NtProgressComponent, NtProgressCircleComponent };
//# sourceMappingURL=progress.js.map
